import java.util.*;


public class KnappsackProblem implements Problem {

	double weight[];
	double value[];
	double maxWeight;

	double alpha;
	
	public KnappsackProblem(double weight[], 
			double value[],
			double maxWeight) {
	
		this.weight = weight;
		this.value = value;
		this.maxWeight = maxWeight;
		alpha = 50;
	}

	public int geneSize() {
		return weight.length;
	}

	public double fitness(boolean[] gene) {
		double vSum = 0;
		double wSum = 0;
		for (int i=0; i<weight.length; i++) {
			if (gene[i]) {
				vSum += value[i];
				wSum += weight[i];
			}
		}

		double fitness = vSum;
		if (wSum > maxWeight) {
		 	fitness += alpha*(maxWeight - wSum);
			fitness = fitness<0?0:fitness;
		}
		return fitness;
	}
	
	public String toString(boolean[] gene) {
		String tmp = "[";
		double wSum = 0;
		for (int i=0; i<gene.length; i++) {
			if (gene[i]) {
				tmp += "("+weight[i]+","+value[i]+") ";
				wSum += weight[i];	
			}
		}
		return tmp+"]->"+maxWeight+">"+ wSum +"| "+fitness(gene);
	}
	
	

	
}
